Index: linux-4.19.118/drivers/net/vxlan.c
===================================================================
--- linux-4.19.118.orig/drivers/net/vxlan.c
+++ linux-4.19.118/drivers/net/vxlan.c
@@ -4091,6 +4091,7 @@ VXLAN_ATTR_FLAG_RO(ipv6_linklocal, VXLAN
 VXLAN_ATTR_FLAG(ttl_inherit, VXLAN_F_TTL_INHERIT);
 VXLAN_ATTR_FLAG(clear_df, VXLAN_F_CLEAR_DF);
 VXLAN_ATTR_FLAG(slave_mtu, VXLAN_F_SLAVE_MTU);
+VXLAN_ATTR_FLAG(vlan_aware, VXLAN_F_VLAN_AWARE);
 
 static struct attribute *vxlan_attrs[] = {
 	&dev_attr_learn.attr,
@@ -4112,6 +4113,7 @@ static struct attribute *vxlan_attrs[] =
 	&dev_attr_ttl_inherit.attr,
 	&dev_attr_clear_df.attr,
 	&dev_attr_slave_mtu.attr,
+	&dev_attr_vlan_aware.attr,
 	NULL
 };
 
@@ -4209,6 +4211,7 @@ int vxlan_fdb_fillbuf(struct vxlan_dev *
 
 				memcpy(fe->eth_addr, f->eth_addr, ETH_ALEN);
 				fe->state = f->state;
+				fe->vlan = f->vlan;
 				fe->flags = f->flags;
 				fe->updated = jiffies_delta_to_clock_t(jiffies - f->updated);
 				fe->used = jiffies_delta_to_clock_t(jiffies - f->used);
@@ -4216,6 +4219,7 @@ int vxlan_fdb_fillbuf(struct vxlan_dev *
 				fe->remote_port_lo = rd->remote_port;
 				fe->remote_port_hi = rd->remote_port >> 8;
 				fe->remote_vni = rd->remote_vni;
+				fe->remote_vlan = rd->remote_vlan;
 				fe->remote_ifindex = rd->remote_ifindex;
 				++fe;
 				++num;
Index: linux-4.19.118/include/net/vxlan.h
===================================================================
--- linux-4.19.118.orig/include/net/vxlan.h
+++ linux-4.19.118/include/net/vxlan.h
@@ -293,6 +293,7 @@ struct __vxlan_fdb_entry {
 	__u8		eth_addr[ETH_ALEN+1];
 	__u16		state; /*see ndm */
 	__u32		vni;
+	__u8		vlan;
 	__u16		flags;
 	__u32		updated;
 	__u32		used;
@@ -300,6 +301,7 @@ struct __vxlan_fdb_entry {
 	__u8		remote_port_lo;
 	__u8		remote_port_hi;
 	__u8		remote_vni;
+	__u8		remote_vlan;
 	__u32		remote_ifindex;
 	__u8		pad[4];
 };
Index: linux-4.19.118/tools/include/uapi/linux/if_link.h
===================================================================
--- linux-4.19.118.orig/tools/include/uapi/linux/if_link.h
+++ linux-4.19.118/tools/include/uapi/linux/if_link.h
@@ -531,6 +531,8 @@ enum {
 	IFLA_VXLAN_LABEL,
 	IFLA_VXLAN_GPE,
 	IFLA_VXLAN_TTL_INHERIT,
+	IFLA_VXLAN_VLAN_ID,
+	IFLA_VXLAN_VLAN_AWARE,
 	__IFLA_VXLAN_MAX
 };
 #define IFLA_VXLAN_MAX	(__IFLA_VXLAN_MAX - 1)
